import urllib.request
import urllib.error
import http
import re

# supported playlists: m3u and pls

class PlaylistParser:

    def __init__(self, url):
        self.url = str(url)
        self.playStream = None

    def __reqPlaylist(self):
        req = urllib.request.Request(url=self.url, method='GET')
        try:
            f = urllib.request.urlopen(req)
            if f.status == 200:
                if self.url.endswith('.m3u'):
                    readFlag = 1
                    while readFlag:
                        data = f.readline()
                        if data:
                            data = data.decode(f.info().get_content_charset('utf-8'))
                            if data[0] != '#':
                                self.playStream = data.rstrip()
                                readFlag = 0
                        else:
                            readFlag = 0

                elif self.url.endswith('.pls'):
                    readFlag = 1
                    while readFlag:
                        data = f.readline()
                        if data:
                            data = data.decode(f.info().get_content_charset('utf-8'))
                            match = re.findall("File",data)
                            if match:
                                out = data.split('=')
                                self.playStream = out[1].rstrip()
                                break
                        else:
                            readFlag = 0
                else:
                    print("Not Supported or Invalid playlist URL")

        except urllib.error.URLError as e:
            print(e.reason)
        except http.client.HTTPException as e:
            print(e)

    def getStream(self):
            self.__reqPlaylist()
            return self.playStream


if __name__=="__main__":
    play = PlaylistParser("http://www.radioswissjazz.ch/live/mp3.m3u")
    stream = play.getStream()
    print(stream)
