#!/bin/sh

# script to monitor MPA400 HyperSpike's Temperature Sensor

CHIP_ADDR="0x49"

SET2C=$(which i2cset)
SET2C+=" -y 0"
GET2C=$(which i2cget)
GET2C+=" -y 0"

SET2C+=" $CHIP_ADDR"
GET2C+=" $CHIP_ADDR"

set_reg() {
    echo "Executing $SET2C $1 $2"
    eval "$SET2C $1 $2"
}

get_reg() {
    ret=$(eval "$GET2C $1")
    echo "$ret"
}

check_temp(){
    local TEMP_REG=$(get_reg "0x00")
    echo "Value read: $TEMP_REG"
    echo $TEMP_REG
    TEMP_REG=$(echo "${TEMP_REG}00")
    printf -v TEMP_REG "%d" $TEMP_REG
    local TEMP=$(echo $(( ${TEMP_REG} >> 5 )))
    RES=$(echo "${TEMP}*0.125" | bc)
    echo "${RES%.*}" > /tmp/temp_sensor
}


while :
do
    check_temp
    sleep 2
done

